const app = getApp();
let _this = null;
let reqData = {};

Page({
	
  data: {
		list: null,
		isLoading: false, // 检测是否已经发送请求,防止重复发送请求
		noMore: false, // 检测是否有更多数据,true为没有更多数据,false为还有数据
		pageNum: 1, // 当前页数
		
		startDate: '开始日期',
		endDate: '结束日期',
  },
	
  onLoad: function(options) {
		_this = this;
		
		this.setData({
			options,
			currentDate: this.currentDate(),	
		});
		
		
		
		
  },
	
  onShow: function() {
		reqData.url = '/api/weshop/marketing/servicewrite/page';
		reqData.data = {
			storeId: app.globalData.setting.stoid,
		};
		
		if(this.data.options.userid) {
			reqData.data.userId = this.data.options.userid;
			_this.getData(true, reqData.url, reqData.data);
		} else {
			reqData.data.userId = app.globalData.user_id;
			this.isLogin()
			.then(function(data) {
				_this.getData(true, reqData.url, reqData.data);
			});
		};
    
  },


  onReachBottom: function() {
		this.scrollToLower(reqData.url, reqData.data);
  },
	
	// 判断是否授权登录
	isLogin() {
		return new Promise((resolve, reject) => {
			let user_info = app.globalData.userInfo;
			if(user_info == null || user_info.mobile == undefined || user_info.mobile == "" || user_info.mobile == null) {
			  wx.navigateTo({
			    url: '/packageE/pages/togoin/togoin',
			  })
			} else {
				resolve();
			};
		});
	},
	

	bindDateChange1: function(e) {
		console.log('picker发送选择改变，携带值为', e.detail.value)
		this.setData({
			startDate: e.detail.value
		})
	},
	
	bindDateChange2: function(e) {
		console.log('picker发送选择改变，携带值为', e.detail.value)
		this.setData({
			endDate: e.detail.value
		})
	},
	
  searchOffline() {
		console.log('执行查询');

		let startDate = this.data.startDate;
		let endDate = this.data.endDate;
		
		
		
		if(startDate == '开始日期' || endDate == '结束日期') {
			wx.showToast({
				title: '请选择完整的查询日期!',
				icon: 'none',
			})
		} else if(new Date(startDate) > new Date(endDate)) {
			wx.showToast({
				title: '出错了，开始日期不能晚于结束日期!',
				icon: 'none',
			})
			return;
		} else {
			this.setData({
				list: null,
				isLoading: false, // 检测是否已经发送请求,防止重复发送请求
				noMore: false, // 检测是否有更多数据,true为没有更多数据,false为还有数据
				pageNum: 1, // 当前页数
			});
			
			reqData.data.BeginDate = startDate;
			reqData.data.EndDate = endDate;
			reqData.data.page = 1;
			this.getData(true, reqData.url, reqData.data);
		};
		
		
	},
	
	currentDate() { 
		var now = new Date();
		var year = now.getFullYear();       //年
		var month = now.getMonth() + 1;     //月
		var day = now.getDate();            //日
		
		var clock = year + "-";
		
		if(month < 10) month += "0";
		clock += month + "-";
		
		if(day < 10) day += "0";		
		clock += day;
		
		// if(hh < 10)
		// 		clock += "0";
				
		// clock += hh + ":";
		// if (mm < 10) clock += '0'; 
		// clock += mm + ":"; 
		 
		// if (ss < 10) clock += '0'; 
		// clock += ss; 
		return clock; 
	},
	
	
	// 请求数据
	requestData(url, data) {
		return new Promise((resolve, reject) => {
			app.request.promiseGet(url, {data: data})
			.then(res => {
			  if(res.data.code == 0) {
					console.log('resolve', res);
					resolve(res);
			  } else {
					reject(res);
				};
			})
		});
	},
	
	
	// 上拉加载请求数据
	getData: function(isInit, url, data) {
	
			wx.showLoading({
			  title: '加载中',
			});
			this.requestData(url, data).then(function(res) {
				
					wx.hideLoading();
					console.log('res--->', res);
					_this.setData({
						isLoading: false
					});
					
					if(isInit) {// 第一次加载
						_this.setData({
							list: res.data.data
						});
	
					} else {
						_this.setData({
							'list.pageData': _this.data.list.pageData.concat(res.data.data.pageData)
						});
					};
					
					if((res.data.data.pageData.length == 0) || (res.data.data.pageSize * res.data.data.page >= res.data.data.total)) {
						_this.setData({
							noMore: true
						});
					};
				
			}).catch(function() {
				wx.hideLoading();
				_this.setData({
					'list.pageData': []
				});
			});
			// .catch(function(reason) {
			// 	wx.hideLoading();
			// 	wx.showToast({
			// 	  title: reason.data.msg,
			// 	  icon: 'none',
			// 	  duration: 2000
			// 	})
			// 	_this.setData({
			// 		'list.pageData': []
			// 	});
			// })
			// ;
	
	},
	
	
	// 上拉加载
	scrollToLower(url, requestData, callback) {
		// 页面数据
		// let pageData = this.data.list.pageData;
		// 数据总量
		let total = this.data.list.total;
		// 单页最大数据量
		let pageSize = this.data.list.pageSize;
		// 如果数据总量不为0且小于或等于单页最大数据量，说明数据已全部加载，显示‘没有更多了’
		if((total != 0)&&(total <= pageSize)) {
			this.setData({
				noMore: true
			});
		};
		
		if(!this.data.isLoading && !this.data.noMore) {
			this.setData({
				isLoading: true,
				pageNum: this.data.pageNum + 1
			});
			requestData.page = this.data.pageNum;
			this.getData(false, url, requestData);
		};
	},
  
  
});